/*******************************************************************************
+
+  LEDA 5.0  
+
+
+  mixed_model.c
+
+
+  Copyright (c) 1995-2004
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


#include <LEDA/graphics/graphwin.h>

using namespace leda;

#if defined(LEDA_STD_IO_HEADERS)
using std::cout;
using std::endl;
#endif


#include <AGD/MixedModelLayout.h>
#include <AGD/GraphWinInterface.h>


int main()
{
  MixedModelLayout layout;

  GraphWin gw;

  gw.display();
  gw.edit();

  GraphWinInterface I(gw);

  graph& G = gw.get_graph();

  AgdKey agd_key;
  if (!layout.check(G,agd_key)) 
    error_handler(1,"Unsatisfied graph property: " + agd_key.info());

  layout.call(G,I); 

  // get node positions
  node v;
  forall_nodes(v,G) cout << gw.get_position(v) << endl;

  // display result
  gw.set_flush(true);
  gw.zoom_graph();
  gw.edit();

 
}

