/*******************************************************************************
+
+  AGD 1.2
+
+
+  GridConceptBase.h
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


//-------------------------------------------------------------------
//
//                         GridConceptBase.h
//
//    author: Carsten Gutwenger
//    date:   july 1999
//-------------------------------------------------------------------


#ifndef _AGD_GC_BASE_H
#define _AGD_GC_BASE_H


#include <AGD/IRect.h>

class GridLayout;


class __exportAGD GridConceptBase {
	bool  _bbox_set;
	IRect _bbox;

public:

	GridConceptBase() : _bbox_set(false), _glp(nil) { }
	GridConceptBase(GridLayout &gl) : _bbox_set(false), _glp(&gl) { }
	GridConceptBase(const GridConceptBase &gcb) : _bbox_set(gcb._bbox_set),
		_bbox(gcb._bbox), _glp(gcb._glp) { }

	~GridConceptBase() { }

	void set_zero_size();

	void set_bbox (const IRect &bbox);
	const IRect &get_bbox();

	GridLayout &get_layout() const {
		return *_glp;
	}

protected:

	GridLayout *_glp;
};


#endif
