/************************************************************************

         Filename   :   pqStack.h
         Version    :   1.0.3  1997
         Author     :   Sebastian Leipert
         Language   :   C++

************************************************************************/
#ifndef PQSTACK_H
#define PQSTACK_H
#include <LEDA/internal/std/stdio.h>
#include <LEDA/internal/std/stdlib.h>
#include "def.inc"



template<class T> class pqStack;

template<class T>
class T_element{
   friend class pqStack<T>;

private:
   T           key;
   T_element  *next;
   T_element  *pre;
};




template<class T>

class pqStack {

   T_element<T>  *first;
   T_element<T>  *last; 
   T_element<T>  *position;

   int            size;

public:

         pqStack();        
        ~pqStack();       

   void  cleanupStack();
   int   count();   
   T     pop();       
   void  push(T m);
   int   readLast();                  
   T     readNext();
   int   stackEmpty();                  
   void  startAtBottom();
   int   searchAndChange(T oldElement,T newElement);

};


template<class T> void pqStack<T>::cleanupStack()
{
   T_element<T>   *helpptr = NULL;
 
   while (first != NULL)
   {
      helpptr = first;
      first = first->next;
      delete helpptr;
   }
   last = NULL;
   position = NULL;
   size = 0;
} // empty_stack


template<class T> pqStack<T>::pqStack()
{
   first = NULL;
   last = NULL;
   position = NULL;
   size = 0;
} // constructor


template<class T> int pqStack<T>::count()
{
   return size;
} // count


template<class T> pqStack<T>::~pqStack()
{
   T_element<T>   *helpptr = NULL;
   
   while (first != NULL)
   {
      helpptr = first;
      first = first->next;
      delete helpptr;
   }
} //destructor


template<class T> void pqStack<T>::push(T m)
{
   T_element<T>   *helpptr = NULL;

   size++;
   helpptr = new T_element<T>;
   helpptr->key = m;
   helpptr->next = NULL;
   if (first == NULL)
   {
      first = helpptr;
      last = helpptr;
      position = helpptr;
      helpptr->pre = NULL;
   }  
   else
   {
      last->next = helpptr;
      helpptr->pre = last;
      last = helpptr;
   }
} // push


template<class T> T pqStack<T>::pop()
{
   T              helpelem;
   T_element<T>   *helpptr = NULL;


   if (last != NULL)
   {
      if (first == last)
         first = NULL;
      if (position == last)
         position = NULL;
      helpelem = last->key;
      helpptr = last;
      last = last->pre;
      if (last != NULL)
         last->next = NULL;
      size--;
      delete helpptr;
      return helpelem;
   }
   else
   {
      printf("template pqStack: pqStack is empty. wrong access\n");
      return 0;
   }
} // pop


template<class T> int pqStack<T>::readLast()
{
   if (position == NULL)
      return TRUE;
   else 
      return FALSE;
} // readLast


template<class T> T pqStack<T>::readNext()
{
   T   helpelem;

   if (position != NULL)
   {
      helpelem = position->key;
      position = position->next;
      return helpelem;
   }
   else
   {
      printf("template pqStack: Tried to read nonexisting element\n");
      return 0;
   }
} // readNext


template<class T> int pqStack<T>::stackEmpty()
{
   if (first == NULL)
     return TRUE;
   else
     return FALSE;
}  // stack_empty


template<class T> void  pqStack<T>::startAtBottom()
{
   position = first;
} // startAtBottom


template<class T> int pqStack<T>::searchAndChange(T oldel,T newel)
{
   int  found = FALSE;
   
   position = first;
   while (position != NULL && !found)
   {
      if (position->key == oldel)
      {
          position->key = newel;
          found = TRUE;
      }
      position = position->next;
   }
   return found;
} // searchAndChange




#endif

