/*******************************************************************************
+
+  AGD 1.2
+
+
+  PlanGridConcept.h
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


//-------------------------------------------------------------------
//
//                      PlanGridConcept.h
//
//    author: Carsten Gutwenger
//    date:   octobre 1998
//-------------------------------------------------------------------


#ifndef _AGD_PLAN_GC_CONCEPT_H
#define _AGD_PLAN_GC_CONCEPT_H


#include <AGD/impl/GCGridConceptBase.h>

class PlaneGraphCopy;


class __exportAGD PlanGridConcept : public GCGridConceptBase {

	const leda::graph *_cgp;
	leda::face _ext_face;

	bool new_graph, new_layout, _is_planar;

	// forbid copying
	PlanGridConcept (const PlanGridConcept &) { }
	PlanGridConcept &operator=(const PlanGridConcept &) {
		return *this;
	}

public:

	PlanGridConcept (const leda::graph &G, LayoutInterface &A);	
	PlanGridConcept (const leda::graph &G, leda::face f, LayoutInterface &A);
	PlanGridConcept (PlaneGraphCopy &PG, leda::face f, LayoutInterface &A);

	PlanGridConcept (const leda::graph &G, GridLayout &gl);
	PlanGridConcept (const leda::graph &G, leda::face f, GridLayout &gl);
	PlanGridConcept (PlaneGraphCopy &PG, leda::face f, GridLayout &gl);


	~PlanGridConcept();


	void get_node_grid_size (GridCoordinateMapper &,
		const LayoutInterface &) { }
	void get_node_grid_size (const GridLayout &) { }

	void update (GridCoordinateMapper &gcm, LayoutInterface &A);
	void update (GridLayout &gl);


	const leda::graph &get_const_graph() const {
		return *_cgp;
	}

	PlaneGraphCopy &get_graph() const {
		return *(PlaneGraphCopy *)(_gcp);
	}

	bool is_planar() const {
		return _is_planar;
	}

	leda::face get_exterior_face() {
		return _ext_face;
	}

	static void set_postcondition(leda::list<AgdKey> &post);
};


#endif
