/*********************************************************************

  FILENAME  : extendedPlanGraph.h
  VERSION   : 1.0.0
  AUTHOR    : Christoph Liebel
  LANGUAGE  : C++

*********************************************************************/

#ifndef EXTENDEDPLANGRAPH_H
#define EXTENDEDPLANGRAPH_H

#include "AGD/impl/planarity/planGraph.h"
#include "AGD/impl/PQTree/pqQueue.h"



class extendedPlanGraph : public planGraph {

  public:

    extendedPlanGraph();
    ~extendedPlanGraph();

    virtual void completeEmbedding(leafKey<outEdge,int,int>** virtualElements,
                                   int* oTA, int* aTO, 
				   pqQueue<int>** embedVirtual,
                                   int cluster, int numberOfEdges);
    virtual int connectionTest();
    basicList<outEdge>* getAdjList() const;
    basicList<outEdge>* getAdjList(int number) const;
    int getM() const;
    int getN() const;
	virtual int readGraph(char* filename) { return planGraph::readGraph(filename); }
    virtual void readGraph(int pqNodes, int edges, basicList<outEdge>* helpAdjList,
                             int* helpDirect, double* helpWeight, const char* helpName);


};

#endif


