/************************************************************************

         Filename   :   basicGraph.h
         Version    :   1.0.1
         Author     :   Christoph Buchheim
         Language   :   C++

************************************************************************/

#ifndef BASICGRAPH_H
#define BASICGRAPH_H

#ifdef NOAGD

#include "basicList.h"
#include "outEdge.h"

#else

#include "AGD/impl/planarity/basicList.h"
#include "AGD/impl/planarity/outEdge.h"

#endif


class basicGraph {

protected:
  
int n,m,mSingle;
int weightes;
basicList<outEdge> *adjacencyList;
int *direction;
double *weight;
char graphName[128];

  
int countMulti();


public:
  
basicGraph();
virtual ~basicGraph();
virtual void deleteGraph();

#if NOAGD 

virtual int readGraph(char*);
virtual void writeGraph(int,char* filename=0);

#else

virtual int readGraph(char*) { return 0; };
virtual void writeGraph(int,char* /*filename*/=0) { };

#endif

};

#endif

