/************************************************************************

         Filename      :   nodeData.h
         Version       :   1.0.2
         Author        :   Christoph Buchheim/ Sebastian Leipert
         Modified      :   Sebastian Leipert 
         Last Modifed  :   15/12/99  1.0.1
         Language      :   C++

************************************************************************/

#ifndef NODEDATA_H
#define NODEDATA_H


#ifdef NOAGD

#include "outEdge.h"
#include "leafKey.h"
#include "pqStack.h"
#include "basicList.h"

#else

#include "AGD/impl/planarity/outEdge.h"
#include "AGD/impl/PQTree/leafKey.h"
#include "AGD/impl/PQTree/pqStack.h"
#include "AGD/impl/planarity/basicList.h"

#endif


template<class T,class X,class Y>
class nodeData {
  friend class planGraph;
  friend class extendedPlanGraph;  // Needed for c-planarity test in AGD
  nodeData();
  ~nodeData();
  int dfsNumber,lowpoint;
  outEdge toLowpoint,father;
  pqStack<outEdge> aEdges,bEdges,cEdges;
  int marked;
  leafKey<T,X,Y> **higherNumbered,**lowerNumbered;
  int higherCount,lowerCount;
  pqStack<int> *toBeReversed,*notToBeReversed;
  basicList<outEdge> *upwardAdjacencyList;
};



template<class T,class X,class Y>
nodeData<T,X,Y>::nodeData():
  dfsNumber(0),marked(0),higherNumbered(0),lowerNumbered(0),
    higherCount(0),lowerCount(0) {
  toBeReversed=new pqStack<int>;
  notToBeReversed=new pqStack<int>;
  upwardAdjacencyList=new basicList<outEdge>;
}

template<class T,class X,class Y>
nodeData<T,X,Y>::~nodeData() {
  if (toBeReversed) delete toBeReversed;
  if (notToBeReversed) delete notToBeReversed;
  if (upwardAdjacencyList) delete upwardAdjacencyList;
  if(higherNumbered) delete[] higherNumbered;
  if(lowerNumbered) delete[] lowerNumbered;
}

#endif


