/************************************************************************

         Filename      :   nodeData.h
         Version       :   1.0.2
         Author        :   Christoph Buchheim/ Sebastian Leipert
         Modified      :   Sebastian Leipert 
         Last Modifed  :   08/02/00  1.0.1
         Language      :   C++

************************************************************************/

#ifndef PLANGRAPH_H
#define PLANGRAPH_H

#ifdef NOAGD

#include "basicGraph.h"
#include "nodeData.h"
#include "PQdirected.h"


#else

#include "AGD/impl/planarity/basicGraph.h"
#include "AGD/impl/planarity/nodeData.h"
#include "AGD/impl/planarity/PQdirected.h"

#endif


class planGraph : public basicGraph {

public:
  
planGraph();
virtual ~planGraph();
int embedGraph(int=1,int *st=0);
int embedGraph(PQdirected<outEdge,int,int>* &,int=1,int=1,int *st=0);
int isPlanar();
int isPlanarC();
virtual void deleteGraph();
virtual int readGraph(char*);



protected:
  
int embedded;
basicList<outEdge>* embeddedAdjacencyList;
nodeData<outEdge,int,int>* D;
int stCount;
int* stNode;
int* marked;

PQdirected<outEdge,int,int>* PQ; // Needed by c-planarity test in AGD.



  
void entireEmbed(int);




private:
  
void addSTEdge(int,outEdge);
pqStack<int>* findPath(int);
void findSTEdges(int);
int upwardEmbed(int = 1);
int search(int,int&);
int search(int,int&,int);



};


#endif

