/*******************************************************************************
+
+  AGD 1.2
+
+
+  random_tree.c
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/



#include <AGD/AGD.h>
#include <AGD/generators.h>
#include <LEDA/graph/graph.h>
#include <LEDA/core/array.h>

using namespace leda;


void random_tree(graph &G, int n, int max_deg, int max_width)
{
	random_source& rs = AGD::get_random_source();

	G.clear();
	G.make_directed();

	if (n <= 0) return;
	if (max_deg   <= 0) max_deg   = n;
	if (max_width <= 0) max_width = n;

	int max = 0;
	array<node> possible(n);
	array<int> width(n+1);
	node_map<int> level(G,0);

	width.init(0);
	level[possible[0] = G.new_node()] = 0;
	--n;

	while(n > 0) {
		int  i = rs(0,max);
		node v = possible[i];

		if (width[level[v]+1] == max_width) {
			possible[i] = possible[max--];
			continue;
		}

		if (G.outdeg(v)+1 == max_deg)
			possible[i] = possible[max--];

		node w = G.new_node();
		possible[++max] = w;
		G.new_edge(v,w);
		width[level[w] = level[v]+1]++;

		--n;
	}
}
