/*******************************************************************************
+
+  AGD 1.2
+
+
+  outEdge.c
+
+
+  Copyright (c) 1998-2003
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


/************************************************************************

         Filename   :   outEdge.cc
         Version    :   1.0.2
         Author     :   Christoph Buchheim, Sebastian Leipert
         Date       :   12.01.2000
         Language   :   C++

************************************************************************/

#ifdef NOAGD

#include "outEdge.h"

#else

#include <AGD/impl/planarity/outEdge.h>

#endif

#include <LEDA/system/basic.h>
#include <LEDA/internal/std/iostream.h>


outEdge::outEdge(int no,int nu,int label)
    :_node(no),_number(nu),_label(label) {};
outEdge::outEdge(int no)
  :_node(no),_number(0) {};
outEdge::outEdge() {};

int outEdge::getNode() const {
  return _node;
}

int outEdge::getNumber() const {
  return _number;
}

int outEdge::operator==(outEdge second) {
  return _node==second.getNode()&&_number==second.getNumber();
}





