/*******************************************************************************
+
+  AGD 1.2
+
+
+  ParallelEdgeRanking.cpp
+
+
+  Copyright (c) 1998-2005
+  by  Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


//-------------------------------------------------------------------
//
//                        ParallelEdgeRanking.cpp
//
//    author: Sven Thiel
//    date:   March 2003
//-------------------------------------------------------------------


#include <AGD/ParallelEdgeRanking.h>

#include <AGD/LongestPathRanking.h>

using namespace leda;

ParallelEdgeRanking::ParallelEdgeRanking()
{
	add_precondition (key::directed);

	PreCond  PRE;
	PostCond POST;
	PRE[1] << key::no_self_loops << key::directed;
	basic_ranking.init(PRE,POST, LongestPathRanking());
}


AGDModule*
ParallelEdgeRanking::clone() const
{
	ParallelEdgeRanking *M = new ParallelEdgeRanking();

	M->set_basic_ranking(basic_ranking.get());

	return M;
}


void ParallelEdgeRanking::call(const graph& G, node_array<int>& rank)
{
	basic_ranking.get().call(G,rank);
	node v;
	forall_nodes(v, G) rank[v] *= 2;
}
