// compression module includes
#include <LEDA/coding/internal/strbuf_helpers.h>

// core library includes
#include <string.h> // for memcpy, memset

#if defined(LEDA_DEBUG)
#include <LEDA/system/assert.h>
#else
#undef assert
#define	assert(cond) ((void)0)
#endif

LEDA_BEGIN_NAMESPACE

/// get_feeder //////////////////////////////////////////////////////////////////////////////

// copied from coder_strbuf_adapter::xsgetn

streamsize 
get_feeder::xsgetn(char* buffer, streamsize count)
{
	streamsize total_read = 0;

	while (count > 0) {
		int pending;
		if (gptr() && (pending = (int)(egptr() - gptr())) > 0) {
			// copy from internal buffer
			if (count < pending) pending = (int)count;
			memcpy(buffer, gptr(), pending);
			buffer += pending; total_read += pending; count -= pending;
			gbump(pending);
			continue;
		}
		
		int c = uflow();
		if (c < 0) {
			if (c == coder_base::StreamBlocked) total_read = coder_base::StreamBlocked - total_read;
			break;
		}

		*buffer++ = (char) c; ++total_read; --count;
	}

	return total_read;
}

/// put_eater ///////////////////////////////////////////////////////////////////////////////

// copied from coder_strbuf_adapter::xsputn

streamsize 
put_eater::xsputn(const char* buffer, streamsize count)
{
	streamsize total_written = 0;

	while (count > 0) {
		int space;
		if (pptr() && (space = (int)(epptr() - pptr())) > 0) {
			// copy from internal buffer
			if (count < space) space = (int)count;
			memcpy(pptr(), buffer, space);
			buffer += space; total_written += space; count -= space;
			pbump(space);
			continue;
		}
		
		int c = overflow((coder_base::byte)*buffer);
		if (c < 0) {
			if (c == coder_base::StreamBlocked) total_written = coder_base::StreamBlocked - 1 - total_written;
				// NOTE: "-1" because one overflow character was written
			break;
		}

		++buffer; ++total_written; --count;
	}

	return total_written;
}

LEDA_END_NAMESPACE
