@echo off

set wait_on_err=no

if *%1 == *replinc goto :replinc

rem %1: compiler
rem %2: "dll" (optional)
rem %3: opts  (optional)

set cc=unknown

if "%1" == "g++"       		set cc=gcc
if "%1" == "gcc"			set cc=gcc
if "%1" == "bcc"			set cc=bcc
if "%1" == "dmc"			set cc=dmc
if "%1" == "wcc"			set cc=wcc
if "%1" == "msc"			set cc=msc
if "%1" == "msc-mt"			set cc=msc
if "%1" == "msc-mt-15"		set cc=msc
if "%1" == "msc6"			set cc=msc6
if "%1" == "msc64"			set cc=msc64
if "%1" == "msc64-mt"		set cc=msc64
if "%1" == "msc64-mt-15"	set cc=msc64
if "%1" == "mwc"			set cc=mwc
if "%1" == "icc"			set cc=icc

if "%1" == "msc-mt" goto :do_mt
if "%1" == "msc64-mt" goto :do_mt
if "%1" == "msc64-mt-15" goto :do_mt
if "%1" == "msc-mt-15" goto :do_mt

copy incl\LEDA\internal\config-st.h incl\LEDA\internal\config.h > NUL
goto :end_mt
:do_mt 
copy incl\LEDA\internal\config-mt.h incl\LEDA\internal\config.h > NUL
:end_mt


set sys=unknown
if not "%windir%"    == "" set sys=win32
if %cc% == msc64           set sys=win64
if not "%os2_shell%" == "" set sys=os2

 
set confdir=confdir


if not %sys% == win32 goto :skipgcc
if not %cc%  == gcc   goto :skipgcc
set sys=win32gcc
:skipgcc

set opts=%2
if *%2 == *dll set opts=%3
if *%opts% == *debug set opts=Debug
if *%opts% == *DEBUG set opts=Debug


if "%1" == "" goto :usage
if not "%2" == "dll" goto :no_dll
if not exist %confdir%\%sys%dll\%cc%\cc goto  :dll_error
:no_dll



if exist leda.lic del leda.lic > NUL
if "%4" == "skiplic" goto :skiplic 
if "%3" == "skiplic" goto :skiplic
%confdir%\util\%sys%\license.exe leda.lic
if not exist leda.lic goto :quit
goto lic_ok

:skiplic
set wait_on_err=yes

:lic_ok


::ECHO E100"SET VAR="> debug_script                                              
::FOR %%_ IN (RCX 8 NFILE1.BAT W Q) DO ECHO %%_>> debug_script                  
::DEBUG <debug_script >NUL                                                      
::DEL debug_script  

::chdir >> FILE1.BAT
::call FILE1.BAT
::del FILE1.BAT

::echo %var%
::::for /R incl/LEDA %%f in (*.h) do  xcopy %%f %var%\incl_old\LEDA\



echo @echo off                                     > def.tmp
if %sys% == win32    echo set wdir=mswin          >> def.tmp
if %sys% == win32gcc echo set wdir=mswin          >> def.tmp
if %sys% == os2      echo set wdir=os2            >> def.tmp
if %cc% == wcc       echo set make=wmake -u -h    >> def.tmp
if %cc% == msc       echo set make=nmake -nologo  >> def.tmp
if %cc% == msc6      echo set make=nmake -nologo  >> def.tmp
if %cc% == msc64     echo set make=nmake -nologo  >> def.tmp
if %cc% == bcc       echo set make=make           >> def.tmp
if %cc% == dmc       echo set make=make           >> def.tmp
if %cc% == gcc       echo set make=make           >> def.tmp
if %cc% == icc       echo set make=nmake -nologo  >> def.tmp
if %cc% == mwc       echo set make=nmake -nologo  >> def.tmp
if not *%opts% == *  echo set opts=%opts%>> def.tmp

copy def.tmp + %confdir%\make\make_lib.bat  make_lib.bat  > NUL
copy def.tmp + %confdir%\make\make_prog.bat make_prog.bat > NUL
copy def.tmp + %confdir%\make\make_test.bat make_test.bat > NUL
copy def.tmp + %confdir%\make\make_demo.bat make_demo.bat > NUL

echo set clean=clean >> def.tmp
copy def.tmp + %confdir%\make\make_lib.bat  make_clean.bat > NUL

del def.tmp > NUL

::copy %confdir%\make\make_setup.bat make_setup.bat > NUL
copy %confdir%\make\build_setup_prog.bat build_setup_prog.bat > NUL



if "%2" == "dll" goto :start_dll
echo.
set config_dir=%confdir%\%sys%
echo.
echo Setting up makefiles to build static libraries for %sys% with %cc% ...

if %cc% == mwc echo confdir\win32\mwc\mwc_lib >> make_lib.bat

goto :end_dll

:start_dll
set config_dir=%confdir%\%sys%dll
echo.
echo Setting up makefiles to build DLL's for %sys% with %cc% ...
echo make_dll %%1 >> make_lib.bat
copy %config_dir%\%cc%\make_dll.bat make_dll.bat > NUL

if %cc%*%opts% == msc*Debug copy %config_dir%\%cc%\make_dll_debug.bat make_dll.bat > NUL

if %cc%*%opts% == msc*Debug copy %config_dir%\%cc%\leda_mld.rc leda_mld.rc > NUL
if %cc% == msc copy %config_dir%\%cc%\leda_%3.rc > NUL
if %cc%*%3 == msc* copy %config_dir%\%cc%\leda.rc > NUL
if %cc% == msc6 copy %config_dir%\%cc%\leda_%3.rc > NUL
if %cc%*%3 == msc6* copy %config_dir%\%cc%\leda.rc > NUL


:end_dll


if not exist %config_dir%\%cc%\cc%opts% goto :usage

copy  %config_dir%\%cc%\cc%opts% cc.tmp > NUL
copy  %config_dir%\%cc%\cc%opts%.pro cc_pro.tmp > NUL

echo. >> cc.tmp
if %cc% == bcc goto :asm_bcc
if %cc% == msc64 goto :asm_yasm
echo ASM = nasm -Dwin32 -f win32 >> cc.tmp
goto :asm_end
:asm_yasm
echo ASM = yasm -m amd64 -f win32 >> cc.tmp
goto :asm_end
:asm_bcc
echo ASM = nasm -Dwin32 -Dobj -f obj   >> cc.tmp
:asm_end
echo. >> cc.tmp


if not %cc% == msc goto :skip_xlib
if "%2" == "dll" goto :skip_xlib
echo XLIB = user32.lib gdi32.lib msimg32.lib comdlg32.lib shell32.lib advapi32.lib wsock32.lib >> cc.tmp
:skip_xlib

if not %cc% == mwc goto :skip_xlib1
if "%2" == "dll" goto :skip_xlib1
echo XLIB = -lkernel32.lib -luser32.lib -lgdi32.lib -lmsimg32.lib -lcomdlg32.lib -lshell32.lib -ladvapi32.lib -lwsock32.lib >> cc.tmp
:skip_xlib1

if not %cc% == msc6 goto :skip_xlib2
if "%2" == "dll" goto :skip_xlib2
echo XLIB = user32.lib gdi32.lib msimg32.lib comdlg32.lib shell32.lib advapi32.lib wsock32.lib >> cc.tmp
:skip_xlib2

if "%1" == "msc64-mt-15" goto :new_ms_comp
if "%1" == "msc-mt-15" goto :new_ms_comp
if exist src\makefile copy cc.tmp + %config_dir%\make.src src\make.src  > NUL
if exist %config_dir%\%cc%\make.src copy %config_dir%\%cc%\make.src src > NUL
if exist src1\makefile copy cc.tmp + %config_dir%\make.src src1\make.src  > NUL
if exist %config_dir%\%cc%\make.src copy %config_dir%\%cc%\make.src src1 > NUL
if exist AGD\src\makefile copy cc.tmp + %config_dir%\makeagd.src AGD\src\Make.src > NUL

if not exist cc_pro.tmp copy cc.tmp cc_pro.tmp > NUL
copy cc_pro.tmp + %config_dir%\make.pro test\make.pro > NUL
copy cc_pro.tmp + %config_dir%\make.pro demo\make.pro > NUL

if not exist prog\makefile goto :skip1
copy cc_pro.tmp + %config_dir%\make.pro prog\make.pro > NUL
goto :end_new_ms_comp
:new_ms_comp

if exist src\makefile copy cc.tmp + %config_dir%\make-15.src src\make.src  > NUL
if exist %config_dir%\%cc%\make.src copy %config_dir%\%cc%\make-15.src src > NUL
if exist src1\makefile copy cc.tmp + %config_dir%\make-15.src src1\make.src  > NUL
if exist %config_dir%\%cc%\make.src copy %config_dir%\%cc%\make-15.src src1 > NUL
if exist AGD\src\makefile copy cc.tmp + %config_dir%\makeagd-15.src AGD\src\Make.src > NUL

if not exist cc_pro.tmp copy cc.tmp cc_pro.tmp > NUL
copy cc_pro.tmp + %config_dir%\make-15.pro test\make.pro > NUL
copy cc_pro.tmp + %config_dir%\make-15.pro demo\make.pro > NUL

if not exist prog\makefile goto :skip1
copy cc_pro.tmp + %config_dir%\make-15.pro prog\make.pro > NUL
:end_new_ms_comp
:skip1

del cc.tmp > NUL
del cc_pro.tmp > NUL


copy demo\anim\makefile.ms       demo\anim\makefile  > NUL
copy demo\d2_geo\makefile.ms     demo\d2_geo\makefile     > NUL
copy demo\d3_geo\makefile.ms     demo\d3_geo\makefile     > NUL
copy demo\geowin\makefile.ms     demo\geowin\makefile     > NUL
copy demo\graph_alg\makefile.ms  demo\graph_alg\makefile  > NUL
copy demo\graph_draw\makefile.ms demo\graph_draw\makefile > NUL
copy demo\graphwin\makefile.ms   demo\graphwin\makefile   > NUL
copy demo\window\makefile.ms     demo\window\makefile     > NUL
copy demo\xlman\makefile.ms      demo\xlman\makefile      > NUL



REM Replace "include" by "!include" for borland and watcom makefiles

copy %confdir%\util\%sys%\replinc.exe . > NUL

if %cc% == gcc goto :skip2
if %cc% == dmc goto :skip2
if %cc% == emx goto :skip2
if %cc% == ztc goto :skip2
if %cc% == msc goto :skip2
if %cc% == msc6 goto :skip2
if %cc% == msc64 goto :skip2
if %cc% == mwc goto :skip2
if %cc% == icc goto :skip2

if not exist src\makefile goto :skip_src
echo updating makefiles in src ...
call %0 replinc replinc src
echo done ...

if not exist src1\makefile goto :skip_src
echo updating makefiles in src ...
call %0 replinc replinc src1
echo done ...

if not exist AGD\src\makefile goto :skip_agd
REM chdir AGD\src
echo updating makefiles in AGD ...
REM for /d %%x in (*) do ..\..\replinc %%x\makefile
REM chdir ..\..\
call %0 replinc replinc AGD
:skip_agd

:skip_src


if not exist test\makefile goto :skip_test
REM chdir test
echo updating makesfiles in test ...
REM for /d %%x in (*) do ..\replinc %%x\makefile
call %0 replinc replinc test

REM chdir ..
:skip_test


if not exist demo\makefile goto :skip_demo
REM chdir demo
echo updating makefiles in demo ...
REM for /d %%x in (*) do ..\replinc %%x\makefile
REM chdir ..
call %0 replinc replinc demo
:skip_demo


if not exist prog\makefile goto :skip_prog
chdir prog
for /d %%x in (*) do ..\replinc %%x\makefile
chdir ..
:skip_prog

:skip2

del replinc.exe > NUL



if not %cc% == wcc goto :skip3
ren src\geowin  src\geowin_  > NUL
ren demo\geowin demo\geowin_ > NUL
:skip3

rem if not %cc% == bcc goto :skip4
rem copy demo\geowin\no_member_templates\*.c  demo\geowin > NUL
rem :skip4


echo.
echo Now type "make_lib" to build the LEDA libraries.
echo.

goto :quit


:usage
echo.
echo Usage: lconfig cc [dll] [opts]
echo.
echo Possible compilers (cc) and options (opts) under %sys%:
echo.

if %sys% == win32 goto :win32
if %sys% == win64 goto :win32
if %sys% == os2   goto :os2

:win32
echo g++			: GNU C++ (cygwin)
echo msc			: Microsoft Visual C++ 7/8/9/10/11	(opts: dll md mt mdd mtd)
echo msc-mt			: defines LEDA_MULTI_THREAD		(opts: dll md mt mdd mtd)
echo msc-mt-15		: VS 2015 and VS 2017			(opts: dll md mt mdd mtd)
echo msc6			: Microsoft Visual C++ 6.0		(opts: dll ml md mt mld mdd mtd)
echo msc64			: Microsoft Visual C++ 9/10/11 64 bit	(opts: dll md mt mdd mtd)
echo msc64-mt		: defines LEDA_MULTI_THREAD		(opts: dll md mt mdd mtd)
echo msc64-mt-15		: VS 2015 and VS 2017			(opts: dll md mt mdd mtd)
echo.
if *%wait_on_err% == *no goto :quit
pause
goto :quit

:os2
echo wcc : Watcom C++
echo icc : IBM Cset
echo g++ : GNU C++ (emx)
echo.
if *%wait_on_err% == *no goto :quit
pause
goto :quit


:dll_error
if not %sys% == win32 goto :dll_error1
%confdir%\util\win32\dll_msg.exe
goto :quit
:dll_error1
echo.
echo Sorry, support for Dynamic Link Libraries is not included in the
echo LEDA research version. DLL's for use with Microsoft, Borland,
echo and Watcom compilers for Win32 (NT/95) and OS/2 are distributed by 
echo the Algorithmic Solutions GmbH. For more information please contact
echo.
echo                Algorithmic Solutions 
echo                Schuetzenstrasse 3-5
echo                66123 Saarbruecken 
echo                Germany
echo                email:leda@algorithmic-solutions.com
echo                fax: +49 681 77012646
echo.
if *%wait_on_err% == *no goto :quit
pause
goto :quit

:replinc
rem lconfig-path replinc replinc-path directory
rem %0           %1      %2           %3
cd %3
cd
for %%f in (Makefile) do ..\%2 Makefile
for /d %%x in (*) do call ..\%0 replinc ..\%2 %%x
cd ..
goto :quit2

:quit
set cc=
set sys=
set opts=
set config_dir=
:quit2
