#define LEDA_CHECKING_OFF

#include <LEDA/graph.h>
#include <LEDA/s_graph.h>
#include <LEDA/dimacs_graph.h>


int main(int argc, char** argv)
{
  typedef s_graph<opposite_graph,1,4> static_graph;
  typedef static_graph::node node;
  typedef static_graph::edge edge;

  static_graph G;

  edge_array<int,static_graph>  lcap;
  assert(lcap.use_edge_data(G));

  edge_array<int,static_graph>  ucap;
  assert(ucap.use_edge_data(G));

  edge_array<int,static_graph>  cost;
  assert(cost.use_edge_data(G));

  edge_array<int,static_graph>  flow;
  assert(flow.use_edge_data(G));

  node_array<int,static_graph>  supply;
  assert(supply.use_node_data(G));


  cout << endl;
  cout << "reading DIMACS min cost flow problem from std input ... ";
  cout << flush;

  read_dimacs_mcf(cin,G,supply,lcap,ucap,cost);
  cout << endl;

  int n = G.number_of_nodes();
  int m = G.number_of_edges();

  cout << string("%6d nodes",n) << endl;
  cout << string("%6d edges",m) << endl;
  cout << endl;

/*
  node v;
  forall_nodes(v,G)
     cout << string("%d",supply[v]) << endl;
  cout << endl;

  edge e;
  forall_edges(e,G)
     cout << string("%d %d %d",lcap[e],ucap[e],cost[e]) << endl;
  cout << endl;
*/

  return 0;
}


