#include <LEDA/rational.h>
#include <LEDA/real.h>

#include <LEDA/filtered_integer.h>
/*
#include <LEDA/filtered_rational.h>
#include <LEDA/filtered_integer1.h>
*/

#include <LEDA/list.h>

#if defined(LEDA_STD_IO_HEADERS)
using namespace std;
#endif


main()
{
/*
  filtered_integer i1 = 10;
  filtered_integer i2 = 100;
  filtered_integer i3 = 1000;
  filtered_integer i4 = -i3;
  filtered_integer i5 = (i1-i2) * (i2+i4);

  cout << i1.to_float() << " " << i1 << endl;
  cout << i2.to_float() << " " << i2 << endl;
  cout << i3.to_float() << " " << i3 << endl;
  cout << i4.to_float() << " " << i4 << endl;
  cout << i5.to_float() << " " << i5 << endl;
  cout << endl;
*/

  int N = read_int("N = ");

 
  list<double>    L0;
  list<filtered_integer> L1;
//list<filtered_integer1> L11;
  list<integer>   L2;
//list<filtered_rational>  L3;
  list<rational>  L4;
  list<real>      L5;

  for (int i=0; i<N; i++) 
  { int x = rand_int(-100000,100000);
    L0.append(x);
    L1.append(x);
    //L11.append(x);
    L2.append(x);
    //L3.append(x);
    L4.append(x);
    L5.append(x);
   }
  
  float T = used_time();

  L0.sort();
  cout << string("double   : %5.2f",used_time(T)) << endl;

  double d,dsum=0,dprod=1;
  forall(d,L0) dsum *= d;
  cout << string("addition : %5.2f",used_time(T)) << endl;
  cout << dsum << endl;
  forall(d,L0) dprod *= d;
  cout << string("multiplication : %5.2f",used_time(T)) << endl;
  cout << endl;

  T = used_time();
  L1.sort();
  cout << string("f_integer: %5.2f",used_time(T)) << endl;

  filtered_integer i,isum=0,iprod=1;
  forall(i,L1) isum += i;
  cout << string("addition : %5.2f",used_time(T)) << endl;
  cout << isum << endl;
  forall(i,L1) iprod *= i;
  cout << string("multiplication : %5.2f",used_time(T)) << endl;
  cout << endl;

  T = used_time();
  L1.sort();
  cout << string("f_integer: %5.2f",used_time(T)) << endl;

/*
  filtered_integer1 i1,i1sum=0, i1prod=1;
  forall(i1,L11) i1sum += i1;
  cout << string("addition : %5.2f",used_time(T)) << endl;
  cout << isum << endl;
  forall(i1,L11) i1prod *= i1;
  cout << string("multiplication : %5.2f",used_time(T)) << endl;
  cout << endl;
*/


  T = used_time();
  L2.sort();
  cout << string("integer  : %5.2f",used_time(T)) << endl;

  integer I,Isum=0,Iprod=1;
  forall(I,L2) Isum += I;
  cout << string("addition : %5.2f",used_time(T)) << endl;
  cout << Isum << endl;
/*
  forall(I,L2) Iprod *= I;
  cout << string("multiplication : %5.2f",used_time(T)) << endl;
*/
  cout << endl;

/*
  T = used_time();
  L3.sort();
  cout << string("f_rational: %5.2f",used_time(T)) << endl;

  filtered_rational fx,fxsum=0,fxprod=1;
  forall(fx,L3) fxsum += fx;
  cout << string("addition : %5.2f",used_time(T)) << endl;
  cout << fxsum << endl;
  forall(fx,L3) fxprod *= fx;
  cout << string("multiplication : %5.2f",used_time(T)) << endl;
  cout << endl;
*/


  T = used_time();
  L4.sort();
  cout << string("rational : %5.2f",used_time(T)) << endl;

  rational x,xsum=0,xprod=1;
  forall(x,L4) xsum += x;
  cout << string("addition : %5.2f",used_time(T)) << endl;
  cout << xsum << endl;
  forall(x,L4) xprod *= x;
  cout << string("multiplication : %5.2f",used_time(T)) << endl;
  cout << endl;


  T = used_time();
  L5.sort();
  cout << string("real     : %5.2f",used_time(T)) << endl;

  real r,rsum=0,rprod=1;
  forall(r,L5) rsum += r;
  cout << string("addition : %5.2f",used_time(T)) << endl;
  cout << rsum << endl;
  forall(r,L5) rprod *= r;
  cout << string("multiplication : %5.2f",used_time(T)) << endl;
  cout << endl;

  return 0;
}

