#include <LEDA/window.h>
#include <LEDA/file.h>

using namespace leda;
using std::cout;
using std::endl;

bool select_pixmap(window& W, string s)
{ panel P;
  P.text_item("\\bf Select Pixmap");
  P.string_item("Pixmap",s);
  P.button("select",0);
  P.button("cancel",1);
  P.button("exit",  2);
  int but = P.open(W);
  if (but == 0)
  { string cmd("cp %s /home/naeher/pixmaps/select/%s",~s,~s);
    cmd.replace("&","\\&");
    cout << cmd << endl;
    system(~cmd);
   }
  return (but == 2);
}

int main(int argc, char** argv)
{
   window W(482,644);

   W.display();

   double x = 0;
   double y = 0;
   double hmax = 0;
   string dir = ".";
   string pattern;

   if (argc > 1)
    { dir = argv[1];
      if (argc > 2) pattern = argv[2];
     }
/*
   else
    { dir = "/usr/X11R6/lib/icons";
      panel P;
      P.text_item("Show all xpm pixmaps in");
      P.string_item("directory",dir);
      P.string_item("pattern",pattern);
      P.button("ok");
      P.open(W);
     }
*/

   if (!is_directory(dir))
     error_handler(1,"Could not open directory.");

   list<string> L = get_files(dir);

   list_item it;
   forall_items(it,L)
   { string s = L[it];
     if (pattern.length() > 0 && s.pos(pattern) < 0) 
     L.del_item(it);
    }

   L.sort();

   // text height
   double th = W.pix_to_real(16);

   list<string> L1;

   string fname;
   forall(fname,L)
   { if (fname.pos(".xpm") < 0) continue;
     string fullname = dir + "/" + fname;
     L1.append(fname);

cout << fname << endl;

     char* pr = W.create_pixrect(fullname);
     double w = W.pix_to_real(W.get_width(pr));
     double h = W.pix_to_real(W.get_height(pr));
     W.put_pixrect(x,y,pr);
     W.del_pixrect(pr);

     x += w;
     if (h > hmax) hmax = h;

     if (x+w > W.xmax() || fname == L.tail()) 
     { x = 0;
       y += hmax;
       hmax = 0;
       if (y+h > W.ymax() || fname == L.tail())
       { y = 0;
         double x0,y0;
         while (W.read_mouse(x0,y0) == MOUSE_BUTTON(3))
         { int n = (int)(W.xmax()/w);
           int i = n * int(y0/h) + int(x0/w);
           list_item it =  L1.get_item(i);
           if (select_pixmap(W,L1[it])) exit(1);
         }
         L1.clear();
        }
      }
    }

  W.read_mouse();
}
   
   
   
