#include <LEDA/graph/graph.h>
#include <LEDA/graph/dimacs_graph.h>
#include <LEDA/system/assert.h>

#include <LEDA/graph/node_slot.h>
#include <LEDA/graph/edge_slot.h>



using namespace leda;

using std::cout;
using std::cin;

int main(int argc, char** argv)
{
  graph G;

  node_array<int>  supply(G);
  edge_array<int>  lcap(G);
  edge_array<int>  ucap(G);
  edge_array<int>  cost(G);

  dimacs_mcf D(cin);
  D.translate(G,supply,lcap,ucap,cost);

  bool rev = false;
  bool zero_lcap = false;

  for(int i=1; i<argc; i++)
  { if (string(argv[i]) == "-cost") G.sort_edges(cost);
    if (string(argv[i]) == "-cap")  G.sort_edges(ucap);
    if (string(argv[i]) == "-r")    rev = true;
    if (string(argv[i]) == "-z")    zero_lcap = true;
   }

  if (rev)
  { list<edge> E = G.all_edges();
    E.reverse_items();
    G.sort_edges(E);
   }

  node v;
  forall_nodes(v,G)
    if (G.outdeg(v) == 0 && G.indeg(v) == 0) G.del_node(v);

  if (zero_lcap)
  { edge e;
    forall_edges(e,G) lcap[e] = 0;
   }

  write_dimacs_mcf(cout,G,supply,lcap,ucap,cost);

  return 0;
}

