#include <LEDA/core/quicksort.h>
#include <LEDA/system/assert.h>

using namespace leda;

/*
#include <iostream>

inline float used_time() { return 0; }
inline float used_time(float& x) { x = 0; return 0; }

inline const char* string(const char* s, float) { return s; }
*/

using std::cout;
using std::cin;
using std::flush;
using std::endl;


const int delta = 16;

typedef short int num_type;


inline void swap(num_type& a, num_type& b)
{ num_type tmp = a; a = b; b = tmp; }


extern "C" void sse2_sort_16(num_type* A);

/*
void bubble_sort(num_type* l, num_type* r)
{ while (l < r)
   { for(num_type* p = l; p < r; p++) 
       if (*p > *(p+1)) swap(*p,*(p+1));
     r--;
   }
}
*/


void bubble_sort(num_type* l, num_type* r)
{ while (r > l)
   { num_type* p = l; 
     num_type x = *p;
     while (p < r) 
     { num_type* q = p+1;
       if (x >= *q) 
          *p = *q;
       else
          { *p = x; x = *q; }
       p = q;
      }
     *r-- = x;
   }
}



void odd_even_sort(num_type* l, num_type* r)
{ int n = r-l+1;
  for (int i = 0; i<n; i++)
  { int d = i % 2; 
    for(num_type* p = l+d; p < r; p+=2)
    { //num_type *q = p+1;
      //if (*p > *q) swap(*p,*q);
      num_type a = *p;
      num_type b = *(p+1);
      if (a > b) { *p = b; *(p+1) = a; }
     }
   }
}
     



int main()
{
 int N = read_int("N = ");

 num_type* A = new num_type[N]; 
 num_type* A_stop = A+N;

 num_type* B = new num_type[N]; 
 num_type* B_stop = B+N;


 for(int i=0;i<N; i++) B[i] = N-i;

 float T;

 cout << "bubble_sort:    " << flush;
 for(int i=0;i<N; i++) A[i] = B[i];
 T = used_time();
 for(num_type* p = A; p <= A_stop-delta; p+=delta) bubble_sort(p,p+delta-1);
 cout << string("%5.2f",used_time(T)) << endl;

 cout << "odd_even_sort:  " << flush;
 for(int i=0;i<N; i++) A[i] = B[i];
 T = used_time();
 for(num_type* p = A; p <= A_stop-delta; p+=delta) odd_even_sort(p,p+delta-1);
 cout << string("%5.2f",used_time(T)) << endl;

 cout << "sse2_odd_even:  " << flush;
 for(int i=0;i<N; i++) A[i] = B[i];
 T = used_time();
 for(num_type* p = A; p <= A_stop-delta; p+=delta) sse2_sort_16(p);
 cout << string("%5.2f",used_time(T)) << endl;

 cout << "quicksort:     " << flush;
 T = used_time();
 for(num_type* p = B; p <= B_stop-delta; p+=delta) QUICKSORT_C(p,p+delta-1);
 cout << string("%5.2f",used_time(T)) << endl;

 for(int i=0; i<N; i++)
 { //cout << A[i] << "  " << B[i] << endl;
   assert(A[i] == B[i]);
  }

 return 0;
}


