#include <stdio.h>

#define CACHE_LINE 16

#define CACHE_ALIGN __declspec(align(CACHE_LINE))


void sortXMM8Short(short int *val /*xmm aligned*/ )
{

static const __int64 CACHE_ALIGN consts[10] =
{
0xffff0000ffff0000, 0xffff0000ffff0000,
0x0000ffff0000ffff, 0x0000ffff0000ffff,
0x000000000000ffff, 0xffff000000000000,
0x0000ffff00000000, 0x0000ffff0000ffff,
0xffff0000ffff0000, 0x00000000ffff0000,
};

__asm
{

mov edx, [val] ; get the pointer
lea eax, [consts]


//movdqa xmm0, [edx] ; fetch 8 shorts

movdqu xmm0, [edx] ; fetch 8 shorts

mov ecx, 4 ; number of runs

align 16
swaprun:

// conditional swap of 4 even pairs 0-1,2-3,4-5,6-7
movdqa xmm1, xmm0
movdqa xmm2, xmm0
pslldq xmm0, 2 ; one word left
psrldq xmm1, 2 ; one word right
pmaxsw xmm0, xmm2
pminsw xmm1, xmm2
pand xmm0, [eax+0*16]; ffff0000ffff0000:ffff0000ffff0000 max
pand xmm1, [eax+1*16]; 0000ffff0000ffff:0000ffff0000ffff min
por xmm0, xmm1 ; combine even max:min

// conditional swap of 3 odd pairs 1-2,3-4,5-6
movdqa xmm1, xmm0
movdqa xmm2, xmm0
pslldq xmm0, 2
psrldq xmm1, 2
pmaxsw xmm0, xmm2
pminsw xmm1, xmm2
pand xmm2, [eax+2*16]; ffff000000000000:000000000000ffff
pand xmm0, [eax+3*16]; 0000ffff0000ffff:0000ffff00000000 max
pand xmm1, [eax+4*16]; 00000000ffff0000:ffff0000ffff0000 min
por xmm0, xmm2 ; combine odd pairs and outer words
por xmm0, xmm1

dec ecx ; next run ?
jnz swaprun

//movdqa [edx], xmm0 ; write sorted array
movdqu [edx], xmm0 ; write sorted array
}
}


void sort_xmm_16(short int* A)
{

__asm
{

mov ecx, [A]

mov eax, [ecx+0]
pinsrw xmm1,eax,0
shr eax, 16
pinsrw xmm2,eax,0

mov eax, [ecx+4]
pinsrw xmm1,eax,1
shr eax,16
pinsrw xmm2,eax,1

mov eax, [ecx+8]
pinsrw xmm1,eax,2
shr eax,16
pinsrw xmm2,eax,2

mov eax, [ecx+12]
pinsrw xmm1,eax,3
shr eax,16
pinsrw xmm2,eax,3

mov eax, [ecx+16]
pinsrw xmm1,eax,4
shr eax,16
pinsrw xmm2,eax,4

mov eax, [ecx+20]
pinsrw xmm1,eax,5
shr eax,16
pinsrw xmm2,eax,5

mov eax, [ecx+24]
pinsrw xmm1,eax,6
shr eax,16
pinsrw xmm2,eax,6

mov eax, [ecx+28]
pinsrw xmm1,eax,7
shr eax,16
pinsrw xmm2,eax,7



movdqa xmm0, xmm2
pminsw xmm0, xmm1
pmaxsw xmm2, xmm1
movdqa xmm1, xmm0

pextrw eax, xmm2, 7

pslldq xmm2, 2
pminsw xmm0, xmm2
pmaxsw xmm1, xmm2
movdqa xmm2, xmm0
psrldq xmm2, 2

pinsrw xmm2,eax,7



pextrw eax,xmm2,0
shl eax,16
pextrw ebx,xmm1,0
xor eax,ebx
mov [ecx+0],eax

pextrw eax,xmm2,1
shl eax,16
pextrw ebx,xmm1,1
xor eax,ebx
mov [ecx+4],eax

pextrw eax,xmm2,2
shl eax,16
pextrw ebx,xmm1,2
xor eax,ebx
mov [ecx+8],eax

pextrw eax,xmm2,3
shl eax,16
pextrw ebx,xmm1,3
xor eax,ebx
mov [ecx+12],eax

pextrw eax,xmm2,4
shl eax,16
pextrw ebx,xmm1,4
xor eax,ebx
mov [ecx+16],eax

pextrw eax,xmm2,5
shl eax,16
pextrw ebx,xmm1,5
xor eax,ebx
mov [ecx+20],eax

pextrw eax,xmm2,6
shl eax,16
pextrw ebx,xmm1,6
xor eax,ebx
mov [ecx+24],eax

pextrw eax,xmm2,7
shl eax,16
pextrw ebx,xmm1,7
xor eax,ebx
mov [ecx+28],eax


//movdqu [ecx], xmm1
//movdqu [edx], xmm2
}
}




int main()
{
   short int /*CACHE_ALIGN*/ A[18];

   for(int i=0; i<16; i++)  A[i] = 16-i;

   for(int i=0; i<16; i++) printf("%2d ",A[i]);
   printf("\n");


for(int i=0; i<16; i++)
{ sort_xmm_16(A);
  for(int i=0; i<16; i++) printf("%2d ",A[i]);
  printf("\n");
}

}
